function mse_h = bp_fe(data, data_target, parm, alg, val, val_target)

n_in = columns(data);
n_out = columns(data_target);
n_hid = parm.n_hidden;
n_step= parm.n_step;
n_runs = parm.n_runs;
n_epoch = parm.epoch;

if (nargin < 4 || (nargin > 4 && nargin < 6))
	error("usage: bp_val(data, data_target, parm, algorithm [, val, val_target])");
endif

if ( nargin == 6 && columns(val) != n_in && columns(val_target) != n_out)
	error("training and validation datasets dont have same number of variables")
endif

gset nokey;
purge_tmp_files
mse_h = zeros(n_runs, n_step*n_epoch);

for j=1:n_runs
	bp_init(n_in, n_hid, n_out);
	val_mse = [];
	for i=1:n_step
		[mse fin] = feval(alg, data, data_target, parm);
		if (nargin > 4)
			val_mse(i * n_epoch) = bp_err(val, val_target, parm);
			plot(mse,'b',val_mse,'or');					
		else
			plot(mse,'b');		
		endif
		if (fin)
			break
		endif
	endfor
	mse_h(j,1:columns(mse))=mse;
endfor

plot((1:n_step*n_epoch)',mse_h')

endfunction
