function out = bp_fw(data, parm)

# out = bp_fw(data)
#
# data = (observations, input_dimension)
# w_ji = weight from input i to hidden unit j, (hidden, i_dimension+1)
# w_kj = weight from hidden j to output unit k, (output, hidden+1)
#
# last column of both w_ji and w_kj hold the unit bias

global w_ji w_kj

nr = rows(data);

data = [data ones(nr,1)]';

h_act = parm.h_act;			# hidden units activation function
h_d_act = parm.h_d_act;		# hidden units derivative of activation function
o_act = parm.o_act;			# output units activation function
o_d_act = parm.o_d_act;		# output units derivative of activation function

for i=1:nr
	out(:,i) = feval(o_act, w_kj * [feval(h_act, w_ji * data(:,i)); 1]);
endfor

	out = out';
	
endfunction
